#ifdef flagMAIN

#include <CtrlLib/CtrlLib.h>
#include "DateTimeCtrl.h"

#define LAYOUTFILE "main.lay"
#include <CtrlCore/lay.h>


struct App : public WithAppLayout<TopWindow>
{
	typedef App CLASSNAME;
	
	App()
	{
		CtrlLayout(*this, "DateTimeCtrl test");
		dt <<= GetSysDate();

		
		dt <<= THISBACK(OnSelect);
		repaint = 0;
		selall = 1;
		
		exit <<= THISBACK(Close);
			
		repaint <<= THISBACK(Repaint);
		selall <<= THISBACK(SelectAll);
		
		Sizeable().Zoomable();
		
		for(int i = 10; i < 36; i += 1)
			fontsize.Add(i, AsString(i));

		int fh = StdFont().GetHeight();	
		fontsize <<= fh;
		fontsize <<= THISBACK(OnFontSize);
		
		for(int i = 0; i < 7; i++)
		{
			firstday.Add(i, DayName(i));
		}
		firstday <<= THISBACK(OnFirstDay);
		firstday <<= 1;
		
    }
	

	void Repaint()
	{
		Ctrl::ShowRepaint(repaint * 20);
	}
	
	void SelectAll()
	{
		dt.SelectAll(selall);
		calendar.SelectAll(selall);
	}
	
	void OnFontSize()
	{
		dt.SetFont(StdFont(~fontsize));
	}
	
	void OnFirstDay()
	{
		calendar.FirstDay(~firstday);
		calendar.Refresh();
	}
	
	void OnSelect()
	{
		PromptOK("Date was selected");
	}
};


GUI_APP_MAIN
{
	App().Run();
}

#endif